# #### Configuration
# Base options
TEMPLATE = app
LANGUAGE = C++

CONFIG += qt
QT = core gui opengl
CONFIG -= app_bundle

# Executable name
TARGET = SIRPRO

QMAKE_CXXFLAGS_RELEASE -= -O2
QMAKE_CXXFLAGS_RELEASE += -O3

# Directories
DESTDIR = .
OBJECTS_DIR = build/

mac:INCLUDEPATH += /opt/local/include/eigen3/
unix:INCLUDEPATH += /usr/include/eigen3/
INCLUDEPATH += /usr/local/lib/

# Anttweakbar
mac:LIBS += -L/opt/local/lib/ -lanttweakbar
unix:LIBS += -L/usr/local/lib/ -lAntTweakBar

# Glew
mac:LIBS += -lglew
unix:LIBS += -lGLEW

mac:LIBS += -framework GLUT
!mac:unix:LIBS += -lglut

unix:DEFINES += LINUX

# ##### platform dependent hacks
# Awful problem with windows..
win32:DEFINES += NOMINMAX

# ##### headers and sources
HEADERS += SIR/state.h SIR/timer.h SIR/visualizer.h
SOURCES += SIR/state.cpp SIR/visualizer.cpp SIR/main.cpp

# Solver stuff
HEADERS += SIR/solver25x25/solver_25x25.h SIR/solver25x25/solver_25x25_interface.h
SOURCES += SIR/solver25x25/solver_25x25.cpp SIR/solver25x25/solver_25x25_interface.cpp SIR/solver25x25/matrix_support_25x25.cpp SIR/solver25x25/ldl_25x25.cpp 

